# FoundationClasses
TKernel
Message

# Message_ProgressIndicator Class Reference

Defines abstract interface from program to the "user".
That includes progress indication and user break mechanisms
.

`#include <Message_ProgressIndicator.hxx>`

Inheritance diagram for Message_ProgressIndicator:

[legend]

## Public Member Functions

virtual Standard_EXPORT void | Reset ()
| Drops all scopes and sets scale from 0 to 100, step 1 This scale has name "Step" .
void | SetName (const Standard_CString name)
void | SetName (const Handle(TCollection_HAsciiString)&name)
| Set (optional) name for scale .
void | SetRange (const Standard_Real min, const Standard_Real max)
| Set range for current scale .
void | SetStep (const Standard_Real step)
| Set step for current scale .
void | SetInfinite (const Standard_Boolean isInf=Standard_True)
| Set or drop infinite mode for the current scale .
void | SetScale (const Standard_CString name, const Standard_Real min, const Standard_Real max, const Standard_Real step, const Standard_Boolean isInf=Standard_False)
Standard_EXPORT void | SetScale (const Standard_Real min, const Standard_Real max, const Standard_Real step, const Standard_Boolean isInf=Standard_False)
| Set all parameters for current scale .
Standard_EXPORT void | GetScale (Standard_Real &min, Standard_Real &max, Standard_Real &step, Standard_Boolean &isInf) const
| Returns all parameters for current scale .
Standard_EXPORT void | SetValue (const Standard_Real val)
Standard_EXPORT Standard_Real | GetValue () const
| Set and get progress value at current scale If the value to be set is more than currently set one, or out of range for the current scale, it is limited by that range .
void | Increment ()
void | Increment (const Standard_Real step)
| Increment the progress value by the default of specified step .
Standard_Boolean | NewScope (const Standard_CString name=0)
Standard_Boolean | NewScope (const Handle(TCollection_HAsciiString)&name)
Standard_Boolean | NewScope (const Standard_Real span, const Standard_CString name=0)
Standard_EXPORT Standard_Boolean | NewScope (const Standard_Real span, const Handle(TCollection_HAsciiString)&name)
| Creates new scope on a part of a current scale from current position with span either equal to default step, or specified The scale for the new scope will have specified name and ranged from 0 to 100 with step 1 Returns False if something is wrong in arguments or in current position of progress indicator; scope is opened anyway .
Standard_EXPORT Standard_Boolean | EndScope ()
| Close the current scope and thus return to previous scale Updates position to be at the end of the closing scope Returns False if no scope is opened .
Standard_Boolean | NextScope (const Standard_CString name=0)
Standard_EXPORT Standard_Boolean | NextScope (const Standard_Real span, const Standard_CString name=0)
| Optimized version of { return EndScope() && NewScope(); } .
virtual Standard_EXPORT Standard_Boolean | UserBreak ()
| Should return True if user has send a break signal. Default implementation returns False. .
virtual Standard_EXPORT Standard_Boolean | Show (const Standard_Boolean force=Standard_True)=0
| Update presentation of the progress indicator Called when progress position is changed Flag force is intended for forcing update in case if it is optimized; all internal calls from ProgressIndicator are done with this flag equal to False .
Standard_Real | GetPosition () const
| Returns total progress position on the basic scale ranged from 0. to 1. .
Standard_EXPORT Standard_Integer | GetNbScopes () const
| Returns current number of opened scopes This number is always >=1 as top-level scale is always present .
Standard_EXPORT const Message_ProgressScale & | GetScope (const Standard_Integer index) const
| Returns data for scale of index-th scope The first scope is current one, the last is the top-level one .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Protected Member Functions

Standard_EXPORT | Message_ProgressIndicator ()
| Constructor, just calls own Reset() (not yet redefined) .

## Private Attributes

Standard_Real | myPosition
Message_SequenceOfProgressScale | myScopes

## Constructor & Destructor Documentation

Standard_EXPORT Message_ProgressIndicator::Message_ProgressIndicator | ( |  | ) | `[protected]`

## Member Function Documentation

Standard_EXPORT Standard_Boolean Message_ProgressIndicator::EndScope | ( |  | ) |

Standard_Integer Message_ProgressIndicator::GetNbScopes | ( |  | ) | const`[inline]`

Standard_Real Message_ProgressIndicator::GetPosition | ( |  | ) | const`[inline]`

Standard_EXPORT void Message_ProgressIndicator::GetScale | ( | Standard_Real & | min,
|  | Standard_Real & | max,
|  | Standard_Real & | step,
|  | Standard_Boolean & | isInf
| ) | const

const Message_ProgressScale & Message_ProgressIndicator::GetScope | ( | const Standard_Integer | index | ) | const`[inline]`

Standard_EXPORT Standard_Real Message_ProgressIndicator::GetValue | ( |  | ) | const

Standard_EXPORT const Message_ProgressIndicator::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from MMgt_TShared.

void Message_ProgressIndicator::Increment | ( | const Standard_Real | step | ) | `[inline]`

void Message_ProgressIndicator::Increment | ( |  | ) | `[inline]`

Standard_EXPORT Standard_Boolean Message_ProgressIndicator::NewScope | ( | const Standard_Real | span,
|  | const Handle(TCollection_HAsciiString)& | name
| ) |

Standard_Boolean Message_ProgressIndicator::NewScope | ( | const Standard_Real | span,
|  | const Standard_CString | name = `0`
| ) | `[inline]`

Standard_Boolean Message_ProgressIndicator::NewScope | ( | const Handle(TCollection_HAsciiString)& | name | ) | `[inline]`

Standard_Boolean Message_ProgressIndicator::NewScope | ( | const Standard_CString | name = `0` | ) | `[inline]`

Standard_EXPORT Standard_Boolean Message_ProgressIndicator::NextScope | ( | const Standard_Real | span,
|  | const Standard_CString | name = `0`
| ) |

Standard_Boolean Message_ProgressIndicator::NextScope | ( | const Standard_CString | name = `0` | ) | `[inline]`

virtual Standard_EXPORT void Message_ProgressIndicator::Reset | ( |  | ) | `[virtual]`

void Message_ProgressIndicator::SetInfinite | ( | const Standard_Boolean | isInf = `Standard_True` | ) | `[inline]`

void Message_ProgressIndicator::SetName | ( | const Handle(TCollection_HAsciiString)& | name | ) | `[inline]`

void Message_ProgressIndicator::SetName | ( | const Standard_CString | name | ) | `[inline]`

void Message_ProgressIndicator::SetRange | ( | const Standard_Real | min,
|  | const Standard_Real | max
| ) | `[inline]`

Standard_EXPORT void Message_ProgressIndicator::SetScale | ( | const Standard_Real | min,
|  | const Standard_Real | max,
|  | const Standard_Real | step,
|  | const Standard_Boolean | isInf = `Standard_False`
| ) |

void Message_ProgressIndicator::SetScale | ( | const Standard_CString | name,
|  | const Standard_Real | min,
|  | const Standard_Real | max,
|  | const Standard_Real | step,
|  | const Standard_Boolean | isInf = `Standard_False`
| ) | `[inline]`

void Message_ProgressIndicator::SetStep | ( | const Standard_Real | step | ) | `[inline]`

Standard_EXPORT void Message_ProgressIndicator::SetValue | ( | const Standard_Real | val | ) |

virtual Standard_EXPORT Standard_Boolean Message_ProgressIndicator::Show | ( | const Standard_Boolean | force = `Standard_True` | ) | `[pure virtual]`

virtual Standard_EXPORT Standard_Boolean Message_ProgressIndicator::UserBreak | ( |  | ) | `[virtual]`

## Field Documentation

Standard_Real Message_ProgressIndicator::myPosition `[private]`

Message_SequenceOfProgressScale Message_ProgressIndicator::myScopes `[private]`

The documentation for this class was generated from the following files:

- Message_ProgressIndicator.hxx
- Message_ProgressIndicator.lxx